Index: /NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/DOM/domvvl.F90
===================================================================
--- /NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/DOM/domvvl.F90	(revision 10115)
+++ /NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/DOM/domvvl.F90	(revision 10116)
@@ -768,19 +1044,20 @@
                   ! Correction at last level:
                   jkbot = mbku(ji,jj)
-                  zdo   = hu_0(ji,jj)
+                  zdo = 0._wp
                   DO jk=jkbot,1,-1
-                     zup = 0.5_wp * ( zw(ji  ,jj,jk) + zw(ji+1,jj,jk) ) 
+                     zup = 0.5_wp * ( e1e2t(ji  ,jj)*zw(ji  ,jj,jk) &
+                         &          + e1e2t(ji+1,jj)*zw(ji+1,jj,jk) ) * r1_e1e2u(ji,jj)
                      !
                      ! If there is a step, taper bottom interface:
-                     IF ((hu_0(ji,jj) < 0.5_wp * ( ht_0(ji,jj) + ht_0(ji+1,jj) ) ).AND.(zup>zdo)) THEN
-                        IF ( ht_0(ji+1,jj) < ht_0(ji,jj) ) THEN
-                           zmin = ztap * (zw(ji+1,jj,jk+1)-zw(ji+1,jj,jk))
-                        ELSE
-                           zmin = ztap * (zw(ji  ,jj,jk+1)-zw(ji  ,jj,jk))
-                        ENDIF
-                        zup = MIN(zup, zdo-zmin)
-                     ENDIF
-                     zup = MIN(zup, zdo-zsmall)
-                     pe3_out(ji,jj,jk) = (zdo - zup - e3u_0(ji,jj,jk)) * ( umask(ji,jj,jk) * (1.0_wp - zlnwd) + zlnwd )
+!                     IF ((hu_0(ji,jj) < 0.5_wp * ( ht_0(ji,jj) + ht_0(ji+1,jj) ) ).AND.(jk==jkbot)) THEN
+!                        IF ( ht_0(ji+1,jj) < ht_0(ji,jj) ) THEN
+!                           zmin = ztap * (zw(ji+1,jj,jk+1)-zw(ji+1,jj,jk))
+!                        ELSE
+!                           zmin = ztap * (zw(ji  ,jj,jk+1)-zw(ji  ,jj,jk))
+!                        ENDIF
+!                        zup = MIN(zup, zdo-zmin)
+!                     ENDIF
+                     zup = MIN(zup, zdo+e3u_0(ji,jj,jk)-zsmall)
+                     pe3_out(ji,jj,jk) = (zdo - zup) * ( umask(ji,jj,jk) * (1.0_wp - zlnwd) + zlnwd )
                      zdo = zup
                   END DO
@@ -795,5 +1072,5 @@
                      pe3_out(ji,jj,jk) =       pe3_out(ji,jj,jk)                                   &
                            &               + ( pe3_out(ji,jj,jk) + e3u_0(ji,jj,jk) )               & 
-                           &               / ( hu_0(ji,jj) + 1._wp - umask(ji,jj,1) )              &
+                           &               / ( hu_0(ji,jj) + 1._wp - ssumask(ji,jj) )              &
                            &               * 0.5_wp * r1_e1e2u(ji,jj)                              &
                            &               * ( umask(ji,jj,jk) * (1.0_wp - zlnwd) + zlnwd )        &
@@ -824,19 +1101,20 @@
                   ! Correction at last level:
                   jkbot = mbkv(ji,jj)
-                  zdo   = hv_0(ji,jj)
+                  zdo = 0._wp
                   DO jk=jkbot,1,-1
-                     zup = 0.5_wp * ( zw(ji,jj  ,jk) + zw(ji,jj+1,jk) ) 
+                     zup = 0.5_wp * ( e1e2t(ji,jj  ) * zw(ji,jj  ,jk) & 
+                         &          + e1e2t(ji,jj+1) * zw(ji,jj+1,jk) ) * r1_e1e2v(ji,jj)
                      !
                      ! If there is a step, taper bottom interface:
-                     IF ((hv_0(ji,jj) < 0.5_wp * ( ht_0(ji,jj) + ht_0(ji,jj+1) ) ).AND.(zup>zdo)) THEN
-                        IF ( ht_0(ji,jj+1) < ht_0(ji,jj) ) THEN
-                           zmin = ztap * (zw(ji,jj+1,jk+1)-zw(ji,jj+1,jk))
-                        ELSE
-                           zmin = ztap * (zw(ji  ,jj,jk+1)-zw(ji  ,jj,jk))
-                        ENDIF
-                        zup = MIN(zup, zdo-zmin)
-                     ENDIF
-                     zup = MIN(zup, zdo-zsmall)
-                     pe3_out(ji,jj,jk) = (zdo - zup - e3v_0(ji,jj,jk)) * ( vmask(ji,jj,jk) * (1.0_wp - zlnwd) + zlnwd )
+!                     IF ((hv_0(ji,jj) < 0.5_wp * ( ht_0(ji,jj) + ht_0(ji,jj+1) ) ).AND.(jk==jkbot)) THEN
+!                        IF ( ht_0(ji,jj+1) < ht_0(ji,jj) ) THEN
+!                           zmin = ztap * (zw(ji,jj+1,jk+1)-zw(ji,jj+1,jk))
+!                        ELSE
+!                           zmin = ztap * (zw(ji  ,jj,jk+1)-zw(ji  ,jj,jk))
+!                        ENDIF
+!                        zup = MIN(zup, zdo-zmin)
+!                     ENDIF
+                     zup = MIN(zup, zdo + e3v_0(ji,jj,jk) - zsmall)
+                     pe3_out(ji,jj,jk) = (zdo - zup) * ( vmask(ji,jj,jk) * (1.0_wp - zlnwd) + zlnwd )
                      zdo = zup
                   END DO
@@ -851,5 +1129,5 @@
                      pe3_out(ji,jj,jk) =       pe3_out(ji,jj,jk)                                                       &
                            &               + ( pe3_out(ji,jj,jk) + e3v_0(ji,jj,jk) )                                   & 
-                           &               / ( hv_0(ji,jj) + 1._wp - vmask(ji,jj,1) )                                  &
+                           &               / ( hv_0(ji,jj) + 1._wp - ssvmask(ji,jj) )                                  &
                            &               * 0.5_wp * r1_e1e2v(ji,jj)                                                  &
                                            * ( vmask(ji,jj,jk) * (1.0_wp - zlnwd) + zlnwd )                            &
@@ -883,31 +1161,31 @@
                   ! bottom correction:
                   jkbot = MIN(mbku(ji,jj), mbku(ji,jj+1)) 
-                  zdo = hf_0(ji,jj)
+                  zdo = 0._wp
                   DO jk=jkbot,1,-1
-                     zup =  0.25_wp * (  zw(ji  ,jj  ,jk)  & 
-                           &           + zw(ji+1,jj  ,jk)  & 
-                           &           + zw(ji  ,jj+1,jk)  & 
-                           &           + zw(ji+1,jj+1,jk)  )
+                     zup =  0.25_wp * (  e1e2t(ji  ,jj  ) * zw(ji  ,jj  ,jk)  & 
+                           &           + e1e2t(ji+1,jj  ) * zw(ji+1,jj  ,jk)  & 
+                           &           + e1e2t(ji  ,jj+1) * zw(ji  ,jj+1,jk)  & 
+                           &           + e1e2t(ji+1,jj+1) * zw(ji+1,jj+1,jk)  ) *    r1_e1e2f(ji,jj)
                      !
                      ! If there is a step, taper bottom interface:
-                     IF ((hf_0(ji,jj) < 0.5_wp * ( hu_0(ji,jj  ) + hu_0(ji,jj+1) ) ).AND.(zup>zdo)) THEN
-                        IF ( hu_0(ji,jj+1) < hu_0(ji,jj) ) THEN
-                           IF ( ht_0(ji+1,jj+1) < ht_0(ji  ,jj+1) ) THEN
-                              zmin = ztap * (zw(ji+1,jj+1,jk+1)-zw(ji+1,jj+1,jk))
-                           ELSE
-                              zmin = ztap * (zw(ji  ,jj+1,jk+1)-zw(ji  ,jj+1,jk))
-                           ENDIF
-                        ELSE
-                           IF ( ht_0(ji+1,jj  ) < ht_0(ji  ,jj  ) ) THEN
-                              zmin = ztap * (zw(ji+1,jj  ,jk+1)-zw(ji+1,jj  ,jk))
-                           ELSE
-                              zmin = ztap * (zw(ji  ,jj  ,jk+1)-zw(ji  ,jj  ,jk))
-                           ENDIF
-                        ENDIF
-                        zup = MIN(zup, zdo-zmin)
-                     ENDIF
-                     zup = MIN(zup, zdo-zsmall)
+!                     IF ((hf_0(ji,jj) < 0.5_wp * ( hu_0(ji,jj  ) + hu_0(ji,jj+1) ) ).AND.(jk==jkbot)) THEN
+!                        IF ( hu_0(ji,jj+1) < hu_0(ji,jj) ) THEN
+!                           IF ( ht_0(ji+1,jj+1) < ht_0(ji  ,jj+1) ) THEN
+!                              zmin = ztap * (zw(ji+1,jj+1,jk+1)-zw(ji+1,jj+1,jk))
+!                           ELSE
+!                              zmin = ztap * (zw(ji  ,jj+1,jk+1)-zw(ji  ,jj+1,jk))
+!                           ENDIF
+!                        ELSE
+!                           IF ( ht_0(ji+1,jj  ) < ht_0(ji  ,jj  ) ) THEN
+!                              zmin = ztap * (zw(ji+1,jj  ,jk+1)-zw(ji+1,jj  ,jk))
+!                           ELSE
+!                              zmin = ztap * (zw(ji  ,jj  ,jk+1)-zw(ji  ,jj  ,jk))
+!                           ENDIF
+!                        ENDIF
+!                        zup = MIN(zup, zdo-zmin)
+!                     ENDIF
+                     zup = MIN(zup, zdo+e3f_0(ji,jj,jk)-zsmall)
                      !
-                     pe3_out(ji,jj,jk) = ( zdo - zup - e3f_0(ji,jj,jk) ) & 
+                     pe3_out(ji,jj,jk) = ( zdo - zup ) & 
                                       & *( umask(ji,jj,jk) * umask(ji,jj+1,jk) * (1.0_wp - zlnwd) + zlnwd )
                      zdo = zup
@@ -1006,5 +1284,5 @@
             id3 = iom_varid( numror, 'tilde_e3t_b', ldstop = .FALSE. )
             id4 = iom_varid( numror, 'tilde_e3t_n', ldstop = .FALSE. )
-            id5 = iom_varid( numror, 'hdiv_lf', ldstop = .FALSE. )
+            id5 = iom_varid( numror, 'hdivn_lf', ldstop = .FALSE. )
             !                             ! --------- !
             !                             ! all cases !
@@ -1068,7 +1346,7 @@
                   !                       ! ------------ !
                   IF( id5 > 0 ) THEN  ! required array exists
-                     CALL iom_get( numror, jpdom_autoglo, 'hdiv_lf', hdiv_lf(:,:,:), ldxios = lrxios )
+                     CALL iom_get( numror, jpdom_autoglo, 'hdivn_lf', hdivn_lf(:,:,:), ldxios = lrxios )
                   ELSE                ! array is missing
-                     hdiv_lf(:,:,:) = 0.0_wp
+                     hdivn_lf(:,:,:) = 0.0_wp
                   ENDIF
                ENDIF
@@ -1140,5 +1418,9 @@
                tilde_e3t_b(:,:,:) = 0._wp
                tilde_e3t_n(:,:,:) = 0._wp
-               IF( ln_vvl_ztilde ) hdiv_lf(:,:,:) = 0._wp
+               IF( ln_vvl_ztilde ) THEN 
+                  hdivn_lf(:,:,:) = 0._wp 
+                  un_lf(:,:,:) = 0._wp 
+                  vn_lf(:,:,:) = 0._wp 
+               ENDIF
             END IF
          ENDIF
@@ -1162,5 +1444,5 @@
          IF( ln_vvl_ztilde ) THEN                    ! z_tilde case !
             !                                        ! ------------ !
-            CALL iom_rstput( kt, nitrst, numrow, 'hdiv_lf', hdiv_lf(:,:,:), ldxios = lwxios)
+            CALL iom_rstput( kt, nitrst, numrow, 'hdivn_lf', hdivn_lf(:,:,:), ldxios = lwxios)
          ENDIF
          !
@@ -1179,9 +1461,16 @@
       !!----------------------------------------------------------------------
       INTEGER ::   ioptio, ios
-      !!
-      NAMELIST/nam_vvl/ ln_vvl_zstar, ln_vvl_ztilde, ln_vvl_layer, ln_vvl_ztilde_as_zstar, &
-         &              ln_vvl_zstar_at_eqtor      , rn_ahe3     , rn_rst_e3t            , &
-         &              rn_lf_cutoff               , rn_zdef_max , ln_vvl_dbg                ! not yet implemented: ln_vvl_kepe
-      !!---------------------------------------------------------------------- 
+
+      NAMELIST/nam_vvl/ ln_vvl_zstar               , ln_vvl_ztilde                       , &
+                      & ln_vvl_layer               , ln_vvl_ztilde_as_zstar              , &
+                      & ln_vvl_zstar_at_eqtor      , ln_vvl_zstar_on_shelf               , &
+                      & ln_vvl_adv_cn2             , ln_vvl_adv_fct                      , &
+                      & ln_vvl_lap                 , ln_vvl_blp                          , &
+                      & rn_ahe3_lap                , rn_ahe3_blp                         , &
+                      & rn_rst_e3t                 , rn_lf_cutoff                        , &
+                      & ln_vvl_regrid                                                    , &
+                      & ln_vvl_ramp                , rn_day_ramp                         , &
+                      & ln_vvl_dbg   ! not yet implemented: ln_vvl_kepe
+      !!----------------------------------------------------------------------  
       !
       REWIND( numnam_ref )              ! Namelist nam_vvl in reference namelist : 
@@ -1197,25 +1486,48 @@
          WRITE(numout,*) 'dom_vvl_ctl : choice/control of the variable vertical coordinate'
          WRITE(numout,*) '~~~~~~~~~~~'
-         WRITE(numout,*) '   Namelist nam_vvl : chose a vertical coordinate'
-         WRITE(numout,*) '      zstar                      ln_vvl_zstar   = ', ln_vvl_zstar
-         WRITE(numout,*) '      ztilde                     ln_vvl_ztilde  = ', ln_vvl_ztilde
-         WRITE(numout,*) '      layer                      ln_vvl_layer   = ', ln_vvl_layer
-         WRITE(numout,*) '      ztilde as zstar   ln_vvl_ztilde_as_zstar  = ', ln_vvl_ztilde_as_zstar
+         WRITE(numout,*) '           Namelist nam_vvl : chose a vertical coordinate'
+         WRITE(numout,*) '              zstar                      ln_vvl_zstar   = ', ln_vvl_zstar
+         WRITE(numout,*) '              ztilde                     ln_vvl_ztilde  = ', ln_vvl_ztilde
+         WRITE(numout,*) '              layer                      ln_vvl_layer   = ', ln_vvl_layer
+         WRITE(numout,*) '              ztilde as zstar   ln_vvl_ztilde_as_zstar  = ', ln_vvl_ztilde_as_zstar
+         ! WRITE(numout,*) '           Namelist nam_vvl : chose kinetic-to-potential energy conservation'
+         ! WRITE(numout,*) '                                         ln_vvl_kepe    = ', ln_vvl_kepe
          WRITE(numout,*) '      ztilde near the equator    ln_vvl_zstar_at_eqtor  = ', ln_vvl_zstar_at_eqtor
-         WRITE(numout,*) '      !'
-         WRITE(numout,*) '      thickness diffusion coefficient                      rn_ahe3      = ', rn_ahe3
-         WRITE(numout,*) '      maximum e3t deformation fractional change            rn_zdef_max  = ', rn_zdef_max
+         WRITE(numout,*) '      ztilde on shelves          ln_vvl_zstar_on_shelf  = ', ln_vvl_zstar_on_shelf
+         WRITE(numout,*) '           Namelist nam_vvl : thickness advection scheme'
+         WRITE(numout,*) '              2nd order                  ln_vvl_adv_cn2 = ', ln_vvl_adv_cn2
+         WRITE(numout,*) '              2nd order FCT              ln_vvl_adv_fct = ', ln_vvl_adv_fct                    
+         WRITE(numout,*) '           Namelist nam_vvl : thickness diffusion scheme'
+         WRITE(numout,*) '              Laplacian                  ln_vvl_lap     = ', ln_vvl_lap
+         WRITE(numout,*) '              Bilaplacian                ln_vvl_blp     = ', ln_vvl_blp
+         WRITE(numout,*) '              Laplacian   coefficient    rn_ahe3_lap    = ', rn_ahe3_lap
+         WRITE(numout,*) '              Bilaplacian coefficient    rn_ahe3_blp    = ', rn_ahe3_blp
+         WRITE(numout,*) '           Namelist nam_vvl : layers regriding'
+         WRITE(numout,*) '              ln_vvl_regrid                             = ', ln_vvl_regrid
+         WRITE(numout,*) '           Namelist nam_vvl : linear ramp at startup'
+         WRITE(numout,*) '              ln_vvl_ramp                               = ', ln_vvl_ramp
+         WRITE(numout,*) '              rn_day_ramp                               = ', rn_day_ramp
          IF( ln_vvl_ztilde_as_zstar ) THEN
-            WRITE(numout,*) '      ztilde running in zstar emulation mode (ln_vvl_ztilde_as_zstar=T) '
-            WRITE(numout,*) '         ignoring namelist timescale parameters and using:'
-            WRITE(numout,*) '            hard-wired : z-tilde to zstar restoration timescale (days)'
-            WRITE(numout,*) '                         rn_rst_e3t     = 0.e0'
-            WRITE(numout,*) '            hard-wired : z-tilde cutoff frequency of low-pass filter (days)'
-            WRITE(numout,*) '                         rn_lf_cutoff   = 1.0/rdt'
+            WRITE(numout,*) '           ztilde running in zstar emulation mode; '
+            WRITE(numout,*) '           ignoring namelist timescale parameters and using:'
+            WRITE(numout,*) '                 hard-wired : z-tilde to zstar restoration timescale (days)'
+            WRITE(numout,*) '                                         rn_rst_e3t     =    0.0'
+            WRITE(numout,*) '                 hard-wired : z-tilde cutoff frequency of low-pass filter (days)'
+            WRITE(numout,*) '                                         rn_lf_cutoff   =    1.0/rdt'
          ELSE
-            WRITE(numout,*) '      z-tilde to zstar restoration timescale (days)        rn_rst_e3t   = ', rn_rst_e3t
-            WRITE(numout,*) '      z-tilde cutoff frequency of low-pass filter (days)   rn_lf_cutoff = ', rn_lf_cutoff
+            WRITE(numout,*) '           Namelist nam_vvl : z-tilde to zstar restoration timescale (days)'
+            WRITE(numout,*) '                                         rn_rst_e3t     = ', rn_rst_e3t
+            WRITE(numout,*) '           Namelist nam_vvl : z-tilde cutoff frequency of low-pass filter (days)'
+            WRITE(numout,*) '                                         rn_lf_cutoff   = ', rn_lf_cutoff
          ENDIF
-         WRITE(numout,*) '         debug prints flag                                 ln_vvl_dbg   = ', ln_vvl_dbg
+         WRITE(numout,*) '           Namelist nam_vvl : debug prints'
+         WRITE(numout,*) '                                         ln_vvl_dbg     = ', ln_vvl_dbg
+      ENDIF
+      !
+      IF ( ln_vvl_ztilde.OR.ln_vvl_layer ) THEN 
+         ioptio = 0                      ! Choose one advection scheme at most
+         IF( ln_vvl_adv_cn2         )        ioptio = ioptio + 1
+         IF( ln_vvl_adv_fct         )        ioptio = ioptio + 1
+         IF( ioptio /= 1 )   CALL ctl_stop( 'Choose ONE thickness advection scheme in namelist nam_vvl' )
       ENDIF
       !
@@ -1237,4 +1549,12 @@
       ENDIF
       !
+      ! Use of "shelf horizon depths" should be allowed with s-z coordinates, but we restrict it to zco and zps 
+      ! for the time being
+      IF ( ln_sco ) THEN 
+        ll_shorizd=.FALSE.
+      ELSE
+        ll_shorizd=.TRUE.
+      ENDIF
+      !
 #if defined key_agrif
       IF( (.NOT.Agrif_Root()).AND.(.NOT.ln_vvl_zstar) )   CALL ctl_stop( 'AGRIF is implemented with zstar coordinate only' )
